<?php
/*
  $Id: pagofacil.php,v 2.2 26/06/2007 10:17:15 hpdl Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Released under the GNU General Public License
*/

  class pagofacil {
    var $code, $title, $description, $enabled;

// class constructor
    function pagofacil() {
      global $order;

      $this->code = 'pagofacil';
      $this->title = MODULE_PAYMENT_PAGOFACIL_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_PAGOFACIL_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_PAGOFACIL_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_PAGOFACIL_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_PAGOFACIL_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_PAGOFACIL_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
      $this->form_action_url = 'https://www.cuentadigital.com/stringosc.php';
    }

// class methods
    function update_status() {
      global $order;
      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAGOFACIL_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAGOFACIL_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      global $order, $currencies, $currency;

      if (MODULE_PAYMENT_PAGOFACIL_CURRENCY == 'Selected Currency') {
        $my_currency = $currency;
      } else {
        $my_currency = substr(MODULE_PAYMENT_PAGOFACIL_CURRENCY, 5);
      }
      if (!in_array($my_currency, array('ARS', 'EUR', 'GBP', 'JPY', 'USD'))) {
        $my_currency = 'ARS';
      }
$codigo1=$order->customer['firstname'].$order->customer['lastname'];

$codigo=substr($codigo1, 0, 9);
      $process_button_string = tep_draw_hidden_field('cmd', '_xclick') .
                               tep_draw_hidden_field('id', MODULE_PAYMENT_CUENTADIGITAL_ID) .
                               tep_draw_hidden_field('venc', MODULE_PAYMENT_PAGOFACIL_VENC) .
                               tep_draw_hidden_field('site', STORE_NAME) .
                               tep_draw_hidden_field('codigo', $codigo) .
                               tep_draw_hidden_field('currency_code', $my_currency) .
                               tep_draw_hidden_field('return', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL')) .
                               tep_draw_hidden_field('cancel_return', tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL')) .
                               tep_draw_hidden_field('precio', number_format($order->info['total'] * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency))).
                               tep_draw_hidden_field('desde', MODULE_PAYMENT_PAGOFACIL_ID) .
                               tep_draw_hidden_field('hacia', $order->customer['email_address']);

      return $process_button_string;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAGOFACIL_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Activar Modulo PagoFacil', 'MODULE_PAYMENT_PAGOFACIL_STATUS', 'True', 'Desea aceptar pagos mediante PagoFacil?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Su numero de CuentaDigital', 'MODULE_PAYMENT_CUENTADIGITAL_ID', '1', 'Su numero de CuentaDigital, numero de usuario', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Su E-Mail', 'MODULE_PAYMENT_PAGOFACIL_ID', 'su@email.com', 'La casilla de email que usa para su servicio de PagoFacil con CuentaDigital.com', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Vencimiento de facturas', 'MODULE_PAYMENT_PAGOFACIL_VENC', '7', 'Dias al vencimiento por defecto que tendran las facturas','6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Moneda', 'MODULE_PAYMENT_PAGOFACIL_CURRENCY', 'Selected Currency', 'El tipo de moneda que usara para las transacciones', '6', '6', 'tep_cfg_select_option(array(\'Selected Currency\',\'Only ARS\',\'Only USD\',\'Only CAD\',\'Only EUR\',\'Only GBP\'),', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Mostrar en orden.', 'MODULE_PAYMENT_PAGOFACIL_SORT_ORDER', '0', 'Orden en que se mostraran los cobros, el mas bajo se mostrara primero.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Zona de Pago', 'MODULE_PAYMENT_PAGOFACIL_ZONE', '0', 'Si una zona es seleccionada solo se aceptaran pagos desde dicha zona.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Estado de la orden predeterminada', 'MODULE_PAYMENT_PAGOFACIL_ORDER_STATUS_ID', '0', 'El estado en que quedaran las ordenes luego de generar una factura PagoFacil, se recomienda la opcion de ordenes como: Pendiente', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_CUENTADIGITAL_ID','MODULE_PAYMENT_PAGOFACIL_VENC','MODULE_PAYMENT_PAGOFACIL_STATUS', 'MODULE_PAYMENT_PAGOFACIL_ID', 'MODULE_PAYMENT_PAGOFACIL_CURRENCY', 'MODULE_PAYMENT_PAGOFACIL_ZONE', 'MODULE_PAYMENT_PAGOFACIL_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAGOFACIL_SORT_ORDER');
    }
  }
?>
